<?php
/*
Copyright: © 2009 WebSharks, Inc. ( coded in the USA )
<mailto:support@websharks-inc.com> <http://www.websharks-inc.com/>

Released under the terms of the GNU General Public License.
You should have received a copy of the GNU General Public License,
along with this software. In the main directory, see: /licensing/
If not, see: <http://www.gnu.org/licenses/>.
*/
/*
WARNING: This is a system configuration file, please DO NOT EDIT this file directly!
... Instead, use the widget options panel in WordPress® to override these settings.
*/
/*
Direct access denial.
*/
if (realpath (__FILE__) === realpath ($_SERVER["SCRIPT_FILENAME"]))
	exit;
/*
Detect if we are inside an MU installation.
*/
if (($GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["is_wpmu"] = function_exists ("wpmu_current_site"))/**/
&& (file_exists (dirname (dirname (__FILE__)) . "/wpmu.farm") || file_exists (TEMPLATEPATH . "/wpmu.farm")))
	$GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["is_wpmu_farm"] = true; /* Requires /wpmu.farm file. */
/*
Configure important global values for this widget + default values for options.
*/
$GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["name"] = "Ad Squares"; /* Name. */
$GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["control_w"] = "265"; /* Width of the control box. */
$GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["description"] = "Supports AdSense®, Javascript, XHTML and PHP code.";
/**/
if ($GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["is_wpmu_farm"]) /* PHP code will be disabled under an MU farm. */
	$GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["description"] = "Supports AdSense®, Javascript, XHTML, etc.";
/*
Determine the full url to the directory this plugin resides in.
*/
$GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["dir_url"] = WP_CONTENT_URL . /* URL to the plugin directory. */
preg_replace ("/^(.*?)(\/" . preg_quote (basename (WP_CONTENT_DIR), "/") . ")/", "", dirname (dirname (__FILE__)));
/*
Check if the plugin has been configured *should be set after the first config via options panel*.
*/
$GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["configured"] = get_option ("ws_widget__ad_squares_configured");
/*
Configure the right menu options panel for this software.
*/
$GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["menu-r"] = array ("tools" => true, "tips" => false, "donations" => true);
/*
Configure the file modification time for the syscon.inc.php file.
*/
$GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["filemtime"] = filemtime (__FILE__);
/*
Configure & validate all of the widget options; and set their defaults.
*/
function ws_widget__ad_squares_configure_options_and_their_defaults ($options = FALSE, $per_widget_options = FALSE)
	{
		/*
		Here we build the default options array, which will be merged with the user options.
		It is important to note that sometimes default options may not or should not be pre-filled on an options form.
		These defaults are for the system to use in various ways, we may choose not to pre-fill certain fields.
		In other words, some defaults may be used internally, but to the user, the option will be empty. */
		$default_options = array ( /* Please comment each line for clarity, it is easy to forget things. */
		/**/
		"options_version" => "1.0", /* Used internally to keep runtime files up-to-date. */
		/**/
		"run_deactivation_routines" => "1"); /* Should deactivation routines be processed? */
		/*
		We also build the default widget options array, these get merged on a per-widget basis.
		It is important to note that sometimes default options may not or should not be pre-filled on an options form.
		These defaults are for the system to use in various ways, we may choose not to pre-fill certain fields.
		In other words, some defaults may be used internally, but to the user, the option will be empty. */
		$default_per_widget_options = array ( /* Defaults for widgets, on a per-widget basis. */
		/**/
		"title" => "Ad Squares Widget", /* Ok for this to be empty. */
		/**/
		"squares" => "2", /* Defaults to just 2 squares here. */
		"padding" => "15", /* Default padding is 15 pixels. */
		"shuffle" => "0", /* Shuffling is turned off by default. */
		/**/
		"code_1" => '<img src="' . $GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["dir_url"] . '/images/125x125.png" style="width:125px; height:125px; border:0px;" alt="Ad Square" />',/**/
		"code_2" => '<img src="' . $GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["dir_url"] . '/images/125x125.png" style="width:125px; height:125px; border:0px;" alt="Ad Square" />',/**/
		"code_3" => '<img src="' . $GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["dir_url"] . '/images/125x125.png" style="width:125px; height:125px; border:0px;" alt="Ad Square" />',/**/
		"code_4" => '<img src="' . $GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["dir_url"] . '/images/125x125.png" style="width:125px; height:125px; border:0px;" alt="Ad Square" />',/**/
		"code_5" => '<img src="' . $GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["dir_url"] . '/images/125x125.png" style="width:125px; height:125px; border:0px;" alt="Ad Square" />',/**/
		"code_6" => '<img src="' . $GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["dir_url"] . '/images/125x125.png" style="width:125px; height:125px; border:0px;" alt="Ad Square" />',/**/
		"code_7" => '<img src="' . $GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["dir_url"] . '/images/125x125.png" style="width:125px; height:125px; border:0px;" alt="Ad Square" />',/**/
		"code_8" => '<img src="' . $GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["dir_url"] . '/images/125x125.png" style="width:125px; height:125px; border:0px;" alt="Ad Square" />');
		/*
		Are we dealing with per-widget options here? 
		*/
		if ($per_widget_options !== false): /* If so we need to work differently. */
			/*
			Here they are merged. user options will overwrite some or all defaults. 
			*/
			$WS_WIDGET__per_widget_options = array_merge ($default_per_widget_options, (array)$per_widget_options);
			/*
			Validate each option, possibly reverting back to default if invalid.
			*/
			foreach ($WS_WIDGET__per_widget_options as $key => &$value)
				{
					if (!is_array ($value))
						$value = trim (stripslashes ($value));
					else /* A string, or an array of strings. */
						foreach ($value as $k => $v)
							$value[$k] = trim (stripslashes ($v));
					/**/
					if (!isset ($default_per_widget_options[$key]))
						unset ($WS_WIDGET__per_widget_options[$key]);
					/**/
					else if ($key === "title" && !is_string ($value))
						$value = $default_per_widget_options[$key];
					/**/
					else if ($key === "squares" && (!is_string ($value) || !is_numeric ($value)))
						$value = $default_per_widget_options[$key];
					/**/
					else if ($key === "padding" && (!is_string ($value) || !is_numeric ($value)))
						$value = $default_per_widget_options[$key];
					/**/
					else if ($key === "shuffle" && (!is_string ($value) || !is_numeric ($value)))
						$value = $default_per_widget_options[$key];
					/**/
					else if (preg_match ("/^code_[1-8]$/", $key) && (!is_string ($value) || !strlen ($value)))
						$value = $default_per_widget_options[$key];
				}
			/**/
			return $WS_WIDGET__per_widget_options;
		/*
		Else we are dealing with the main plugin option configuration or validation. 
		*/
		else: /* We need to validate these while checking to see if options were passed in. */
			/*
			Here they are merged. user options will overwrite some or all defaults. 
			*/
			$GLOBALS["WS_WIDGET__"]["ad_squares"]["o"] = array_merge ($default_options, (($options !== false) ? (array)$options : (array)get_option ("ws_widget__ad_squares_options")));
			/*
			Validate each option, possibly reverting back to default if invalid.
			*/
			foreach ($GLOBALS["WS_WIDGET__"]["ad_squares"]["o"] as $key => &$value)
				{
					if (!is_array ($value))
						$value = trim (stripslashes ($value));
					else /* A string, or an array of strings. */
						foreach ($value as $k => $v)
							$value[$k] = trim (stripslashes ($v));
					/**/
					if (!isset ($default_options[$key]))
						unset ($GLOBALS["WS_WIDGET__"]["ad_squares"]["o"][$key]);
					/**/
					else if ($key === "options_version" && (!is_string ($value) || !is_numeric ($value)))
						$value = $default_options[$key];
					/**/
					else if ($key === "run_deactivation_routines" && (!is_string ($value) || !is_numeric ($value)))
						$value = $default_options[$key];
				}
			/**/
			return $GLOBALS["WS_WIDGET__"]["ad_squares"]["o"];
		/**/
		endif;
	}
/*
Now lets call the function.
*/
call_user_func ("ws_widget__ad_squares_configure_options_and_their_defaults");
?>